# bdm::EKFfull Class Reference

Extended Kalman Filter in full matrices. More...

`#include <kalman.h>`

List of all members.

## Public Member Functions
| EKFfull ()
| Default constructor.
void | set_parameters (const shared_ptr< diffbifn > &pfxu, const shared_ptr< diffbifn > &phxu, const mat Q0, const mat R0)
| Set nonlinear functions for mean values and covariance matrices.
void | bayes (const vec &dt)
| Here dt = [yt;ut] of appropriate dimensions.
void | set_statistics (const vec &mu0, const mat &P0)
| set estimates
const mat | _R ()
| access function
void | set_statistics (const vec &mu0, const fsqmat &P0)
const enorm< fsqmat > & | posterior () const
| posterior
shared_ptr< epdf > | shared_posterior ()
| shared posterior
void | from_setting (const Setting &set)
| load basic elements of Kalman from structure
void | validate ()
virtual string | to_string ()
| This method returns a basic info about the current instance.
virtual void | to_setting (Setting &set) const
| This method save all the instance properties into the Setting structure.
void | set_parameters (const mat &A0, const mat &B0, const mat &C0, const mat &D0, const fsqmat &Q0, const fsqmat &R0)
int | _dimx ()
| access function
int | _dimy ()
| access function
int | _dimu ()
| access function
mat | _A ()
| access function
mat | _B ()
| access function
mat | _C ()
| access function
mat | _D ()
| access function
fsqmat | _Q ()
| access function
Constructors
virtual BM * | _copy_ () const
Mathematical operations
virtual void | bayesB (const mat &Dt)
| Batch Bayes rule (columns of Dt are observations).
virtual double | logpred (const vec &dt) const
vec | logpred_m (const mat &dt) const
| Matrix version of logpred.
virtual epdf * | epredictor () const
| Constructs a predictive density .
virtual mpdf * | predictor () const
| Constructs conditional density of 1-step ahead predictor .
Access to attributes
const RV & | _drv () const
void | set_drv (const RV &rv)
void | set_rv (const RV &rv)
double | _ll () const
void | set_evalll (bool evl0)
## Protected Attributes
shared_ptr< diffbifn > | pfxu
| Internal Model f(x,u).
shared_ptr< diffbifn > | phxu
| Observation Model h(x,u).
RV | yrv
| id of output
RV | urv
| id of input
mat | _K
| Kalman gain.
shared_ptr< enorm< fsqmat > > | est
| posterior
enorm< fsqmat > | fy
| marginal on data f(y|y)
RV | drv
| Random variable of the data (optional).
double | ll
| Logarithm of marginalized data likelihood.
bool | evalll
| If true, the filter will compute likelihood of the data record and store it in `ll` . Set to false if you want to save computational time.
int | dimx
| cache of rv.count()
int | dimy
| cache of rvy.count()
int | dimu
| cache of rvu.count()
mat | A
| Matrix A.
mat | B
| Matrix B.
mat | C
| Matrix C.
mat | D
| Matrix D.
fsqmat | Q
| Matrix Q in square-root form.
fsqmat | R
| Matrix R in square-root form.
## Extension to conditional BM
This extension is useful e.g. in Marginalized Particle Filter (bdm::MPF). Alternatively, it can be used for automated connection to DS when the condition is observed
const RV & | _rvc () const
| access function
virtual void | condition (const vec &val)
| Substitute `val` for `rvc`.
RV | rvc
| Name of extension variable.
## Logging of results
virtual void | set_options (const string &opt)
| Set boolean options from a string, recognized are: "logbounds,logll".
virtual void | log_add (logger &L, const string &name="")
| Add all logged variables to a logger.
virtual void | logit (logger &L)
ivec | LIDs
| IDs of storages in loggers 4:[1=mean,2=lb,3=ub,4=ll].
ivec | LFlags
| Flags for logging - same size as LIDs, each entry correspond to the same in LIDs.

## Detailed Description

Extended Kalman Filter in full matrices.

An approximation of the exact Bayesian filter with Gaussian noices and non-linear evolutions of their mean.

## Member Function Documentation

virtual BM* bdm::BM::_copy_ | ( |  | ) | const`[inline, virtual, inherited]`

Copy function required in vectors, Arrays of BM etc. Have to be DELETED manually! Prototype:

     BM* _copy_() const {return new BM(*this);}

Reimplemented in bdm::ARX, bdm::KalmanCh, bdm::EKFCh, and bdm::BMEF.

virtual double bdm::BM::logpred | ( | const vec & | dt | ) | const`[inline, virtual, inherited]`

Evaluates predictive log-likelihood of the given data record I.e. marginal likelihood of the data with the posterior integrated out.

Reimplemented in bdm::ARX, bdm::MixEF, and bdm::multiBM.

References bdm_error.

Referenced by bdm::BM::logpred_m().

The documentation for this class was generated from the following files:

- kalman.h
- kalman.cpp